package org.springblade.estate.feign;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.plugins.Page;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import javax.validation.Valid;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.estate.dto.PratiqueDTO;
import org.springblade.estate.dto.RepairDTO;
import org.springblade.estate.entity.Repair;
import org.springframework.cloud.openfeign.SpringQueryMap;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import org.springblade.estate.entity.Pratique;
import org.springblade.estate.vo.PratiqueVO;
import org.springblade.estate.wrapper.PratiqueWrapper;
import org.springblade.estate.service.IPratiqueService;
import org.springblade.core.boot.ctrl.BladeController;
import java.util.List;
/**
 *  client
 *
 * @author lianghanqiang
 * @since 2021-05-10
 */

@AllArgsConstructor
@RestController
@RequestMapping("/feign/pratique")

public class PratiqueClient implements IPratiqueClient {

    private final IPratiqueService pratiqueService;

        /**
     * 详情
     */
    @Override
    @GetMapping("/detail")
    public PratiqueVO detail(@SpringQueryMap Pratique pratique) {
        Pratique detail = pratiqueService.getOne(Condition.getQueryWrapper(pratique));
        return PratiqueWrapper.build().entityVO(detail);
        }

    /**
     * 查询
     */
    @Override
    @GetMapping("/list")
    public List<PratiqueVO> list(@SpringQueryMap Pratique pratique) {
        return PratiqueWrapper.build().listVO(pratiqueService.list(Condition.getQueryWrapper(pratique)));
        }



    /**
     * 新增
     */
    @Override
    @PostMapping("/save")
    public Pratique save(@Valid @RequestBody Pratique pratique) {
		pratiqueService.save(pratique);
    	return pratique;

    }

    /**
     * 修改
     */
    @Override
    @PostMapping("/update")
    public boolean update(@Valid @RequestBody Pratique pratique) {
        return pratiqueService.updateById(pratique);
        }

    /**
     * 新增或修改
     */
    @Override
    @PostMapping("/submit")
    public boolean submit(@Valid @RequestBody Pratique pratique) {
        return pratiqueService.saveOrUpdate(pratique);
        }


    /**
     * 删除
     */
    @Override
    @PostMapping("/remove")
    public boolean remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
        return pratiqueService.deleteLogic(Func.toLongList(ids));
        }

	@Override
	public R<Page<Pratique>> page(PratiqueDTO pratiqueDTO) {
		Query query = new Query();
		Page<Pratique> queryPage = pratiqueDTO.getPage();
		query.setCurrent(queryPage.getCurrent());
		query.setSize(queryPage.getSize());
		Page<Pratique> result = new Page<>();
		IPage<Pratique> pratiqueIPage = this.pratiqueService.page(Condition.getPage(query), Condition.getQueryWrapper(pratiqueDTO));
		result.setCurrent((int)pratiqueIPage.getCurrent());
		result.setSize((int)pratiqueIPage.getSize());
		result.setRecords(pratiqueIPage.getRecords());
		result.setTotal(pratiqueIPage.getTotal());
		return R.data(result);
	}


}
